Program SpojDb;
{Demonstruje pouit dynamickch promnnch pi tvorb jednoduch databze}
Uses Crt;
const
  FN='Mydb.dat';
type
  PR=^TRec;
  TRec = record
          index:integer;
          PrijmJm:String[30];
          Dalsi:PR;
          znacka:boolean;
        end;{TRec}
var
  PocDb,Aktual,D1:PR;
  Cin:char;
  F1:File of TREC;
procedure CreateDB(var DB:PR);
  begin
    New(DB);
    Writeln('Nov databze ');
    Writeln('Vlo Pjmen a jmno');
    Readln(DB^.PrijmJm);
    DB^.Dalsi:=Nil;
    DB^.index:=1;
    DB^.znacka:=false;
  end;
Procedure DisplayDB(DB:PR);
  begin
    Writeln;Writeln('Databaze ');
    while DB<>nil do
    begin
      with DB^ do
      begin
        If znacka then Write('*') else write(' ');
        Writeln(index:3,' ',PrijmJm);
      end;
    DB:=DB^.dalsi;
    end;
  end;
Procedure ReIndex(DB:PR); {Reindexuje sla zznam}
  Var
    Pom:PR;
    Count:integer;
  begin
    Pom:=DB;
    Count:=1;
    while (Pom^.dalsi <> nil) do
    begin
      Pom^.index:=Count;
      Inc(Count);
      Pom:=Pom^.dalsi;
    end;{while}
    Pom^.index:=Count;
  end;{ReIndex}
Procedure AddRec(DB:PR);{Prida zaznam na konec}
  var
    Pom,DD:PR;
  begin
    DD:=DB;
    while DD^.dalsi<>nil do DD:=DD^.dalsi;{nastav ukazatel DD na posledn zznam}
    New(Pom);
    DD^.dalsi:=Pom;
    Pom^.index:=DD^.index+1;
    Pom^.znacka:=false;
    Writeln('Pidn novho zznamu do databze ');
    Writeln('Vlo Pjmen a jmno');
    Readln(Pom^.PrijmJm);
    Pom^.dalsi:=nil;
  end;{AddRec}
Procedure SaveDB(DB:PR);
  var
    DD:PR;
  begin
    DD:=DB;
    Assign(F1,FN);
    Rewrite(F1);
    While(DD<>nil) do
    begin
      Write(F1,DD^);
      DD:=DD^.dalsi;
    end;
    Close(F1);
  end;{SaveDB}
Procedure LoadDB(var DB:PR);
  var
    Pom1,Pom2:PR;
  begin
    New(DB);
    Pom1:=DB;
    Assign(F1,FN);
    Reset(F1);
    Read(F1,Pom1^);
    Pom1^.dalsi:=nil;
    While not eof(F1) do
    begin
      New(Pom2);
      Read(F1,Pom2^);
      Pom2^.dalsi:=nil;
      Pom1^.dalsi:=Pom2;
      Pom1:=Pom2;
    end;
  end;{LoadDB}
Procedure znackuj(DB:PR);
  var
    CisloZazn:integer;
    Pom:PR;
  begin
    Writeln('Vlo slo zznamu ke oznaceni vyp/zap');
    Read(CisloZazn);
    Pom:=DB;
    While Pom^.index<CisloZazn do Pom:=Pom^.dalsi;
    Pom^.znacka := not Pom^.znacka;
  end;{znackuj}
Procedure Pack(DB:PR);      {Nesmi byt oznackovan prvni zaznam}
  var
    DD,DN:PR;
    CisloZazn:Integer;
  begin    {Prochazim jednotlive zaznamy a zkoumam znacka}
    DD:=DB;
    while DD^.dalsi<>nil do
      begin
        DN:=DD^.dalsi;
        if DN^.znacka then {zaznam je oznacen, tak ho preskocim a uvolnim}
        begin {zruseni oznaceneho zaznamu}
          DD^.dalsi:=DN^.dalsi;
         { Dispose(DN)};
        end{Ruseni zaznamu}
        else DD:=DN;
      end{while DB}
  end;{pack}
Procedure Statistika(DB:PR);  {vype poet zznam: celkem, oznaench, neoznaench}
  var
    pocit1,pocit2 : integer;
    DD,DN : PR;
  begin
    pocit1:=0;
    pocit2:=0;
    DD:=DB;
    DN:=DD;
    if DN^.znacka then inc(pocit1)
                  else inc(pocit2);
    while DD^.dalsi <> nil do
     begin
       DN:=DD^.dalsi;
       if DN^.znacka then inc(pocit1) else inc (pocit2);
     end;{while DB}
      DD:=DN;
      Writeln ('Statistika databze');
      Writeln ('Databze obsahuje: ',(pocit1+pocit2),'zznam');
      Writeln ('z toho:',pocit1,'oznaench',pocit2,'neoznaench')
  end;
begin {=======================  M A I N    ========================}
  ClrScr;
  repeat
    Writeln;
    Writeln('M E N U ');
    Writeln('C      Create database  vytvo novou databazi');
    Writeln('A      Add record       pidej zznam na konec');
    Writeln('M      znackuj record   ozna zznam ');
    Writeln('D      Display ');
    Writeln('L      Load database    nati databzi z disku');
    Writeln('S      Save database    ulo databzi na disk');
    Writeln('P      packuj databazi  zrus znackovane recordy');
    Writeln('X      reindex          pepe indexy zznam');
    Writeln('T      Statistika database                      ');
    Writeln('ESC    Save db and Exit ulo databzi a ukoni program');
    Cin:=ReadKey;
    Cin:=UpCAse(Cin);
    ClrScr;
    Case Cin of
      'A' : AddRec(D1);
      'C' : CreateDB(D1);
      'D' : DisplayDB(D1);
      'S' : SaveDB(D1);
      'L' : LoadDB(D1);
      'M' : znackuj(D1);
      'P' : Pack(D1);
      'T' : Statistika(D1);
      'X' : Reindex(D1);
      else;
    end;{Case Cin}
  until Cin=#27;
end.
